Crud/WebAppCore/WebAppCore/Models/ApplicationType.cs
using System.ComponentModel.DataAnnotations;

namespace WebAppCore.Models
{
    public class ApplicationType
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public string Name { get; set; }
    }
}

Crud/WebAppCore/WebAppCore/Models/Category.cs
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace WebAppCore.Models
{
    public class Category
    {
        [Key]
        public int Id { get; set; }
        [Required]
        public string CategoryName { get; set; }
        [Required]
        [DisplayName("Display Order")]
        [Range(1,int.MaxValue,ErrorMessage ="Display Order for category must be greater than 0")]
        public string DisplayOrder { get; set; }
    }
}

Crud/WebAppCore/WebAppCore/Models/Data/ApplicationDbContext.cs
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace WebAppCore.Models.Data
{
    public class ApplicationDbContext : DbContext
    {
        public ApplicationDbContext(DbContextOptions<ApplicationDbContext> options) : base(options)
        {

        }
        public DbSet<Category> Category { get; set; }
        public DbSet<ApplicationType> ApplicationType { get; set; }
    }
}

Crud/WebAppCore/WebAppCore/Models/ErrorViewModel.cs
using System;

namespace WebAppCore.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Crud/WebAppCore/WebAppCore/Controllers/ApplicationTypeController.cs
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using WebAppCore.Models.Data;
using WebAppCore.Models;

namespace WebAppCore.Controllers
{
    public class ApplicationTypeController : Controller
    {
        private readonly ApplicationDbContext _db;

        public ApplicationTypeController(ApplicationDbContext db)
        {
            _db = db;
        }


        public IActionResult Index()
        {
            IEnumerable<ApplicationType> objList = _db.ApplicationType;
            return View(objList);
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(ApplicationType obj)
        {
            if (ModelState.IsValid)
            {
                _db.ApplicationType.Add(obj);
                _db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(obj);

        }
    }
}

Crud/WebAppCore/WebAppCore/Controllers/CategoryController.cs
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;
using WebAppCore.Models;
using WebAppCore.Models.Data;

namespace WebAppCore.Controllers
{
    public class CategoryController : Controller
    {
        private readonly ApplicationDbContext _db;

        public CategoryController(ApplicationDbContext db)
        {
            _db = db;
        }

        //GET - CREATE
        public IActionResult Index()
        {
            IEnumerable<Category> objList = _db.Category;
            return View(objList);
        }

        public IActionResult Create()
        {
            return View();
        }

        //POST - CREATE
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Create(Category obj)
        {
            if (ModelState.IsValid)
            {
                _db.Category.Add(obj);
                _db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(obj);

        }

        //GET - EDIT
        public IActionResult Edit(int? id)
        {
            if(id == null || id == 0)
            {
                return NotFound();
            }
            var obj = _db.Category.Find(id);
            if(obj == null)
            {
                return NotFound();
            }
            return View(obj);
        }

        //POST - EDIT
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult Edit(Category obj)
        {
            if (ModelState.IsValid)
            {
                _db.Category.Update(obj);
                _db.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(obj);

        }

        //GET - DELETE
        public IActionResult Delete(int? id)
        {
            if (id == null || id == 0)
            {
                return NotFound();
            }
            var obj = _db.Category.Find(id);
            if (obj == null)
            {
                return NotFound();
            }
            return View(obj);
        }

        //POST - DELETE
        [HttpPost]
        [ValidateAntiForgeryToken]
        public IActionResult DeletePost(int? id)
        {
            var obj = _db.Category.Find(id);
            if (obj == null)
            {
                return NotFound();
            }

            _db.Category.Remove(obj);
            _db.SaveChanges();
            return RedirectToAction("Index");
        }
    }
}

Crud/WebAppCore/WebAppCore/Controllers/HomeController.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using WebAppCore.Models;

namespace WebAppCore.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Crud/WebAppCore/WebAppCore/Views/ApplicationType/Create.cshtml
@model WebAppCore.Models.ApplicationType

<form method="post" asp-action="Create">
    <div class="border p-3">
        @*<div asp-validation-summary="ModelOnly" class="text-danger"></div>*@
        <div class="form-group row">
            <h2 class="text-info pl-3">Add Application Type</h2>
        </div>
        <div class="row">
            <div class="col-8">
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="Name"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="Name" class="form-control" />
                        <span asp-validation-for="Name" class="text-danger"></span>
                    </div>

                </div>

                <div class="form-group row">
                    <div class="col-8 offset-4 row">

                        <div class="col">
                            <input type="submit" class="btn btn-info w-100" value="Create" />
                        </div>
                        <div class="col">
                            <a asp-action="Index" class="btn btn-success w-100"><i class="fas fa-sign-out-alt"></i> Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-4">
                @* Keep this empty *@
            </div>
        </div>
    </div>

</form>

@section Scripts{

    @{
        <partial name="_ValidationScriptsPartial" />
    }

}

Crud/WebAppCore/WebAppCore/Views/ApplicationType/Index.cshtml
@model IEnumerable<WebAppCore.Models.ApplicationType>

<div class="container p-3">
    <div class="row pt-4">
        <div class="col-6">
            <h2 class="text-primary">Application Type List</h2>
        </div>
        <div class="col-6 text-right">
            <a asp-action="Create" class="btn btn-primary">
                <i class="fas fa-plus"></i> &nbsp; Create New Application Type
            </a>
        </div>
    </div>

    <br /><br />

    @if (Model.Count() > 0)
    {
        <table class="table table-bordered table-striped" style="width:100%">
            <thead>
                <tr>
                    <th>
                        Name
                    </th>

                    <th></th>
                </tr>
            </thead>
            <tbody>
                @foreach (var obj in Model)
                {
                <tr>
                    <td width="50%">@obj.Name</td>
                    <td class="text-center">
                        <div class="w-75 btn-group" role="group">
                            <a asp-route-Id="@obj.Id" asp-action="Edit" class="btn btn-primary mx-2">
                                <i class="fas fa-edit"></i>
                            </a>
                            <a asp-route-Id="@obj.Id" asp-action="Delete" class="btn btn-danger mx-2">
                                <i class="far fa-trash-alt"></i>
                            </a>
                        </div>
                    </td>
                </tr>
                }
            </tbody>
        </table>
    }
    else
    {
        <p> No application type exists.</p>
    }

</div>

Crud/WebAppCore/WebAppCore/Views/Category/Create.cshtml
@model WebAppCore.Models.Category

<form method="post" asp-action="Create">
    <div class="border p-3">
        <div asp-validation-summary="All" class="text-danger"></div>
        <div class="form-group row">
            <h2 class="text-info pl-3">Add Category</h2>
        </div>
        <div class="row">
            <div class="col-8">
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="CategoryName"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="CategoryName" class="form-control" />
                        <span asp-validation-for="CategoryName" class="text-danger"></span>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="DisplayOrder"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="DisplayOrder" class="form-control" />
                        <span asp-validation-for="DisplayOrder" class="text-danger"></span>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-8 offset-4 row">

                        <div class="col">
                            <input type="submit" class="btn btn-info w-100" value="Create" />
                        </div>
                        <div class="col">
                            <a asp-action="Index" class="btn btn-success w-100"><i class="fas fa-sign-out-alt"></i> Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-4">
                @* Keep this empty *@
            </div>
        </div>
    </div>
</form>

@*Convert server side model validation to client side
when using this it will not go to model.isvalid*@
@section Scripts{

    @{
        <partial name="_ValidationScriptsPartial" />
    }

}

Crud/WebAppCore/WebAppCore/Views/Category/Delete.cshtml
@model WebAppCore.Models.Category

<form method="post" asp-action="DeletePost">
    <input asp-for="Id" hidden />
    <div class="border p-3">
        <div class="form-group row">
            <h2 class="text-info pl-3">Delete Category</h2>
        </div>
        <div class="row">
            <div class="col-8">
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="CategoryName"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="CategoryName" class="form-control" disabled/>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="DisplayOrder"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="DisplayOrder" class="form-control" disabled/>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-8 offset-4 row">

                        <div class="col">
                            <input type="submit" class="btn btn-danger w-100" value="Delete" />
                        </div>
                        <div class="col">
                            <a asp-action="Index" class="btn btn-success w-100"><i class="fas fa-sign-out-alt"></i> Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-4">
                @* Keep this empty *@
            </div>
        </div>
    </div>
</form>

@*Convert server side model validation to client side
    when using this it will not go to model.isvalid*@
@section Scripts{

    @{
        <partial name="_ValidationScriptsPartial" />
    }

}

Crud/WebAppCore/WebAppCore/Views/Category/Edit.cshtml
@model WebAppCore.Models.Category

<form method="post">
    <input asp-for="Id" hidden />
    <div class="border p-3">
        <div class="form-group row">
            <h2 class="text-info pl-3">Edit Category</h2>
        </div>
        <div class="row">
            <div class="col-8">
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="CategoryName"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="CategoryName" class="form-control" />
                        <span asp-validation-for="CategoryName" class="text-danger"></span>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-4">
                        <label asp-for="DisplayOrder"></label>
                    </div>
                    <div class="col-8">
                        <input asp-for="DisplayOrder" class="form-control" />
                        <span asp-validation-for="DisplayOrder" class="text-danger"></span>
                    </div>

                </div>
                <div class="form-group row">
                    <div class="col-8 offset-4 row">

                        <div class="col">
                            <input type="submit" class="btn btn-info w-100" value="Update" />
                        </div>
                        <div class="col">
                            <a asp-action="Index" class="btn btn-success w-100"><i class="fas fa-sign-out-alt"></i> Back</a>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-4">
                @* Keep this empty *@
            </div>
        </div>
    </div>
</form>

@*Convert server side model validation to client side
    when using this it will not go to model.isvalid*@
@section Scripts{

    @{
        <partial name="_ValidationScriptsPartial" />
    }

}

Crud/WebAppCore/WebAppCore/Views/Category/Index.cshtml
@model IEnumerable<WebAppCore.Models.Category>

<div class="container" p-3>
    <div class="row pt-4">
        <div class="col-6">
            <h2 class="text-primary">Category List</h2>
        </div>
        <div class="col-6 text-right">
            <a asp-action="Create" asp-controller="Category" class="btn btn-primary">
                Create New Category
            </a>
        </div>
    </div>
</div>

<br/><br/>

@if(Model.Count() > 0)
 {
    <table class="table table-bordered table-striped" style="width:100%">
        <thead>
            <tr>
                <th>
                    Category Name
                </th>
                <th>
                    Display Order
                </th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @foreach(var obj in Model)
             {
            <tr>
                <td width="50%">@obj.CategoryName</td>
                <td width="50%">@obj.DisplayOrder</td>
                <td class="text-center">
                    <div class="w-75 btn-group" role="group">
                        <a asp-controller="Category" asp-route-Id="@obj.Id" asp-action="Edit" class="btn btn-primary mx-2">
                            Edit
                        </a>
                        <a asp-controller="Category" asp-route-Id="@obj.Id" asp-action="Delete" class="btn btn-danger mx-2">
                            Delete
                        </a>
                    </div>
                </td>
            </tr>
             }
        </tbody>
    </table>
}
else
{
    <p>No category exist</p>
}

Crud/WebAppCore/WebAppCore/Views/Home/Index.cshtml
@{
    ViewData["Title"] = "Home Page";
}

<div class="text-center">
    <h1 class="display-4">Welcome</h1>
    <p>Learn about <a href="https://docs.microsoft.com/aspnet/core">building Web apps with ASP.NET Core</a>.</p>
</div>

Crud/WebAppCore/WebAppCore/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - WebAppCore</title>
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
    <link rel="stylesheet" href="~/css/site.css" />
</head>
<body>
    <header>
        <nav class="navbar navbar-expand-sm navbar-toggleable-sm navbar-light bg-white border-bottom box-shadow mb-3">
            <div class="container">
                <a class="navbar-brand" asp-area="" asp-controller="Home" asp-action="Index">WebAppCore</a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target=".navbar-collapse" aria-controls="navbarSupportedContent"
                        aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>
                <div class="navbar-collapse collapse d-sm-inline-flex justify-content-between">
                    <ul class="navbar-nav flex-grow-1">
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Index">Home</a>
                        </li>
                        <li class="nav-item">
                            @*<a class="nav-link text-dark" asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>*@
                            <a class="nav-link text-dark" asp-area="" asp-controller="Category" asp-action="Index">Category</a>
                        </li>
                    </ul>
                </div>
            </div>
        </nav>
    </header>
    <div class="container">
        <main role="main" class="pb-3">
            @RenderBody()
        </main>
    </div>

    <footer class="border-top footer text-muted">
        <div class="container">
            &copy; 2021 - WebAppCore - <a asp-area="" asp-controller="Home" asp-action="Privacy">Privacy</a>
        </div>
    </footer>
    <script src="~/lib/jquery/dist/jquery.min.js"></script>
    <script src="~/lib/bootstrap/dist/js/bootstrap.bundle.min.js"></script>
    <script src="~/js/site.js" asp-append-version="true"></script>
    @await RenderSectionAsync("Scripts", required: false)
</body>
</html>